## llvm-20.1.8-2.src.tar.zst

=== lib/hwasan/CMakeLists.txt ===
include_directories(..)

# Runtime library sources and build flags.
set(HWASAN_RTL_SOURCES
  hwasan.cpp
  hwasan_allocator.cpp
  hwasan_allocation_functions.cpp
  hwasan_dynamic_shadow.cpp
  hwasan_exceptions.cpp
  hwasan_fuchsia.cpp
  hwasan_globals.cpp
  hwasan_interceptors.cpp
  hwasan_interceptors_vfork.S
  hwasan_linux.cpp
  hwasan_memintrinsics.cpp
  hwasan_poisoning.cpp
  hwasan_report.cpp
  hwasan_thread.cpp
  hwasan_thread_list.cpp
  hwasan_type_test.cpp
  )

foreach(arch ${HWASAN_SUPPORTED_ARCH})
  if(${arch} MATCHES "aarch64")
    list(APPEND HWASAN_RTL_SOURCES
      hwasan_setjmp_aarch64.S
      hwasan_tag_mismatch_aarch64.S
      )
  endif()
  if(${arch} MATCHES "riscv64")
    list(APPEND HWASAN_RTL_SOURCES
      hwasan_setjmp_riscv64.S
      hwasan_tag_mismatch_riscv64.S
      )
  endif()
  if(${arch} MATCHES "x86_64")
    list(APPEND HWASAN_RTL_SOURCES
      hwasan_setjmp_x86_64.S
      )
  endif()
endforeach()

set(HWASAN_RTL_CXX_SOURCES
  hwasan_new_delete.cpp
  )

set(HWASAN_RTL_PREINIT_SOURCES
  hwasan_preinit.cpp
  )

set(HWASAN_RTL_HEADERS
  hwasan.h
  hwasan_allocator.h
  hwasan_dynamic_shadow.h
  hwasan_flags.h
  hwasan_flags.inc
  hwasan_globals.h
  hwasan_interface_internal.h
  hwasan_malloc_bisect.h
  hwasan_mapping.h
  hwasan_poisoning.h
  hwasan_report.h
  hwasan_thread.h
  hwasan_thread_list.h
  )

set(HWASAN_DEFINITIONS)
append_list_if(COMPILER_RT_HWASAN_WITH_INTERCEPTORS HWASAN_WITH_INTERCEPTORS=1 HWASAN_DEFINITIONS)

if(FUCHSIA)
  # Set this explicitly on Fuchsia, otherwise the default value is set to HWASAN_WITH_INTERCEPTORS.
  list(APPEND HWASAN_DEFINITIONS HWASAN_REPLACE_OPERATORS_NEW_AND_DELETE=1)
endif()

set(HWASAN_RTL_CFLAGS ${SANITIZER_COMMON_CFLAGS})
append_rtti_flag(OFF HWASAN_RTL_CFLAGS)
append_list_if(COMPILER_RT_HAS_FPIC_FLAG -fPIC HWASAN_RTL_CFLAGS)
# Prevent clang from generating libc calls.
append_list_if(COMPILER_RT_HAS_FFREESTANDING_FLAG -ffreestanding HWASAN_RTL_CFLAGS)

# Too many existing bugs, needs cleanup.
append_list_if(COMPILER_RT_HAS_WNO_FORMAT -Wno-format HWASAN_RTL_CFLAGS)

set(HWASAN_DYNAMIC_LINK_FLAGS ${SANITIZER_COMMON_LINK_FLAGS})

if(ANDROID)
# Put most Sanitizer shared libraries in the global group. For more details, see
# android-changes-for-ndk-developers.md#changes-to-library-search-order
  if (COMPILER_RT_HAS_Z_GLOBAL)
    list(APPEND HWASAN_DYNAMIC_LINK_FLAGS -Wl,-z,global)
  endif()
endif()

set(HWASAN_DYNAMIC_CFLAGS ${HWASAN_RTL_CFLAGS})
append_list_if(COMPILER_RT_HAS_FTLS_MODEL_INITIAL_EXEC
  -ftls-model=initial-exec HWASAN_DYNAMIC_CFLAGS)
append_list_if(MSVC /DEBUG HWASAN_DYNAMIC_LINK_FLAGS)

set(HWASAN_DYNAMIC_LIBS
  ${COMPILER_RT_UNWINDER_LINK_LIBS}
  ${SANITIZER_CXX_ABI_LIBRARIES}
  ${SANITIZER_COMMON_LINK_LIBS})

append_list_if(COMPILER_RT_HAS_LIBDL dl HWASAN_DYNAMIC_LIBS)
append_list_if(COMPILER_RT_HAS_LIBRT rt HWASAN_DYNAMIC_LIBS)
append_list_if(COMPILER_RT_HAS_LIBM m HWASAN_DYNAMIC_LIBS)
append_list_if(COMPILER_RT_HAS_LIBPTHREAD pthread HWASAN_DYNAMIC_LIBS)

# Static runtime library.
add_compiler_rt_component(hwasan)

add_compiler_rt_object_libraries(RTHwasan
  ARCHS ${HWASAN_SUPPORTED_ARCH}
  SOURCES ${HWASAN_RTL_SOURCES}
  ADDITIONAL_HEADERS ${HWASAN_RTL_HEADERS}
  CFLAGS ${HWASAN_RTL_CFLAGS}
  DEFS ${HWASAN_DEFINITIONS})
add_compiler_rt_object_libraries(RTHwasan_cxx
  ARCHS ${HWASAN_SUPPORTED_ARCH}
  SOURCES ${HWASAN_RTL_CXX_SOURCES}
  ADDITIONAL_HEADERS ${HWASAN_RTL_HEADERS}
  CFLAGS ${HWASAN_RTL_CFLAGS}
  DEFS ${HWASAN_DEFINITIONS})
add_compiler_rt_object_libraries(RTHwasan_dynamic
  ARCHS ${HWASAN_SUPPORTED_ARCH}
  SOURCES ${HWASAN_RTL_SOURCES} ${HWASAN_RTL_CXX_SOURCES}
  ADDITIONAL_HEADERS ${HWASAN_RTL_HEADERS}
  CFLAGS ${HWASAN_DYNAMIC_CFLAGS}
  DEFS ${HWASAN_DEFINITIONS})
add_compiler_rt_object_libraries(RTHwasan_preinit
  ARCHS ${HWASAN_SUPPORTED_ARCH}
  SOURCES ${HWASAN_RTL_PREINIT_SOURCES}
  ADDITIONAL_HEADERS ${HWASAN_RTL_HEADERS}
  CFLAGS ${HWASAN_RTL_CFLAGS}
  DEFS ${HWASAN_DEFINITIONS})

file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/dummy.cpp "")
add_compiler_rt_object_libraries(RTHwasan_dynamic_version_script_dummy
  ARCHS ${HWASAN_SUPPORTED_ARCH}
  SOURCES ${CMAKE_CURRENT_BINARY_DIR}/dummy.cpp
  CFLAGS ${HWASAN_DYNAMIC_CFLAGS}
  DEFS ${HWASAN_DEFINITIONS})

# If use_aliases is TRUE, adds the HWASan runtime built with alias support.
# Otherwise adds the runtime without alias support.
function(add_hwasan_runtimes arch use_aliases)
  set(hwasan_object_lib RTHwasan)
  set(hwasan_object_dyn_lib RTHwasan_dynamic)
  set(hwasan_runtime clang_rt.hwasan)
  set(hwasan_rtl_flags ${HWASAN_RTL_CFLAGS})
  set(hwasan_dyn_flags ${HWASAN_DYNAMIC_CFLAGS})
  if(use_aliases)
    list(APPEND hwasan_rtl_flags -DHWASAN_ALIASING_MODE)
    list(APPEND hwasan_dyn_flags -DHWASAN_ALIASING_MODE)
    add_compiler_rt_object_libraries(RTHwasanAliases
      ARCHS ${arch}
      SOURCES ${HWASAN_RTL_SOURCES}
      ADDITIONAL_HEADERS ${HWASAN_RTL_HEADERS}
      CFLAGS ${hwasan_rtl_flags}
      DEFS ${HWASAN_DEFINITIONS})
    add_compiler_rt_object_libraries(RTHwasanAliases_dynamic
      ARCHS ${arch}
      SOURCES ${HWASAN_RTL_SOURCES} ${HWASAN_RTL_CXX_SOURCES}
      ADDITIONAL_HEADERS ${HWASAN_RTL_HEADERS}
      CFLAGS ${hwasan_dyn_flags}
      DEFS ${HWASAN_DEFINITIONS})

    set(hwasan_object_lib RTHwasanAliases)
    set(hwasan_object_dyn_lib RTHwasanAliases_dynamic)
    set(hwasan_runtime clang_rt.hwasan_aliases)
  endif()
  add_compiler_rt_runtime(${hwasan_runtime}
    STATIC
    ARCHS ${arch}
    OBJECT_LIBS ${hwasan_object_lib}
                RTHwasan_preinit
                RTInterception
                RTSanitizerCommon
                RTSanitizerCommonLibc
                RTSanitizerCommonCoverage
                RTSanitizerCommonSymbolizer
                RTSanitizerCommonSymbolizerInternal
                RTLSanCommon
                RTUbsan
    CFLAGS ${hwasan_rtl_flags}
    PARENT_TARGET hwasan)
  add_compiler_rt_runtime(${hwasan_runtime}_cxx
    STATIC
    ARCHS ${arch}
    OBJECT_LIBS RTHwasan_cxx
    CFLAGS ${hwasan_rtl_flags}
    PARENT_TARGET hwasan)

  if (UNIX)
    add_sanitizer_rt_version_list(${hwasan_runtime}-dynamic-${arch}
                                  LIBS ${hwasan_runtime}-${arch} ${hwasan_runtime}_cxx-${arch}
                                  EXTRA hwasan.syms.extra)
    set(VERSION_SCRIPT_FLAG
         -Wl,--version-script,${CMAKE_CURRENT_BINARY_DIR}/${hwasan_runtime}-dynamic-${arch}.vers)
    set_property(SOURCE
      ${CMAKE_CURRENT_BINARY_DIR}/dummy.cpp
      APPEND PROPERTY
      OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${hwasan_runtime}-dynamic-${arch}.vers)
  else()
    set(VERSION_SCRIPT_FLAG)
  endif()


  add_compiler_rt_runtime(${hwasan_runtime}
    SHARED
    ARCHS ${arch}
    OBJECT_LIBS
            ${hwasan_object_dyn_lib}
            RTInterception
            RTSanitizerCommon
            RTSanitizerCommonLibc
            RTSanitizerCommonCoverage
            RTSanitizerCommonSymbolizer
            RTSanitizerCommonSymbolizerInternal
            RTLSanCommon
            RTUbsan
            RTUbsan_cxx
            # The only purpose of RTHWAsan_dynamic_version_script_dummy is to
            # carry a dependency of the shared runtime on the version script.
            # Replacing it with a straightforward
            # add_dependencies(clang_rt.asan-dynamic-${arch} clang_rt.asan-dynamic-${arch}-version-list)
            # generates an order-only dependency in ninja.
            RTHwasan_dynamic_version_script_dummy
    CFLAGS ${hwasan_dyn_flags}
    LINK_FLAGS ${HWASAN_DYNAMIC_LINK_FLAGS}
              ${VERSION_SCRIPT_FLAG}
    LINK_LIBS ${HWASAN_DYNAMIC_LIBS}
    DEFS ${ASAN_DYNAMIC_DEFINITIONS}
    PARENT_TARGET hwasan)

  if(SANITIZER_USE_SYMBOLS)
    add_sanitizer_rt_symbols(${hwasan_runtime}
      ARCHS ${arch}
      EXTRA hwasan.syms.extra)
    add_sanitizer_rt_symbols(${hwasan_runtime}_cxx
      ARCHS ${arch}
      EXTRA hwasan.syms.extra)
    add_dependencies(hwasan ${hwasan_runtime}-${arch}-symbols
                          ${hwasan_runtime}_cxx-${arch}-symbols)
  endif()
endfunction()

foreach(arch ${HWASAN_SUPPORTED_ARCH})
  add_hwasan_runtimes(${arch} FALSE)
  if(${arch} MATCHES "x86_64")
    add_hwasan_runtimes(${arch} TRUE)
  endif()
endforeach()

add_compiler_rt_runtime(clang_rt.hwasan-preinit
  STATIC
  ARCHS ${HWASAN_SUPPORTED_ARCH}
  OBJECT_LIBS RTHwasan_preinit
  CFLAGS ${HWASAN_RTL_CFLAGS}
  PARENT_TARGET hwasan)

add_compiler_rt_resource_file(hwasan_ignorelist hwasan_ignorelist.txt hwasan)

add_subdirectory("scripts")

# if(COMPILER_RT_INCLUDE_TESTS)
#   add_subdirectory(tests)
# endif()

=== lib/orc/CMakeLists.txt ===
# Build for all components of the ORC runtime support library.

# ORC runtime library common implementation files.
set(ORC_COMMON_SOURCES
  debug.cpp
  dlfcn_wrapper.cpp
  extensible_rtti.cpp
  log_error_to_stderr.cpp
  run_program_wrapper.cpp
  resolve.cpp
  )

# Common implementation headers will go here.
set(ORC_COMMON_IMPL_HEADERS
  adt.h
  common.h
  compiler.h
  endianness.h
  error.h
  executor_address.h
  extensible_rtti.h
  simple_packed_serialization.h
  stl_extras.h
  wrapper_function_utils.h
  )

# Now put it all together...
include_directories(..)
include_directories(../../include)

set(ORC_CFLAGS
  ${COMPILER_RT_COMMON_CFLAGS}
  ${COMPILER_RT_CXX_CFLAGS})
set(ORC_LINK_FLAGS ${COMPILER_RT_COMMON_LINK_FLAGS})
set(ORC_LINK_LIBS
  ${COMPILER_RT_UNWINDER_LINK_LIBS}
  ${COMPILER_RT_CXX_LINK_LIBS})

# Allow the ORC runtime to reference LLVM headers.
foreach (DIR ${LLVM_INCLUDE_DIR} ${LLVM_MAIN_INCLUDE_DIR})
  list(APPEND ORC_CFLAGS -I${DIR})
endforeach()

add_compiler_rt_component(orc)

# ORC uses C++ standard library headers.
if (TARGET cxx-headers OR HAVE_LIBCXX)
  set(ORC_DEPS cxx-headers)
endif()

if (APPLE)
  set(ORC_ASM_SOURCES
    macho_tlv.x86-64.S
    macho_tlv.arm64.S
    sysv_reenter.arm64.S
    sysv_reenter.x86-64.S
    )

  set(ORC_IMPL_HEADERS
    ${ORC_COMMON_IMPL_HEADERS}
    macho_platform.h
    )

  set(ORC_SOURCES
    ${ORC_COMMON_SOURCES}
    macho_platform.cpp
    )

  add_compiler_rt_object_libraries(RTOrc
    OS ${ORC_SUPPORTED_OS}
    ARCHS ${ORC_SUPPORTED_ARCH}
    SOURCES ${ORC_SOURCES} ${ORC_ASM_SOURCES}
    ADDITIONAL_HEADERS ${ORC_IMPL_HEADERS}
    CFLAGS ${ORC_CFLAGS}
    DEPS ${ORC_DEPS})

  add_compiler_rt_runtime(orc_rt
    STATIC
    OS ${ORC_SUPPORTED_OS}
    ARCHS ${ORC_SUPPORTED_ARCH}
    OBJECT_LIBS RTOrc
    CFLAGS ${ORC_CFLAGS}
    LINK_FLAGS ${ORC_LINK_FLAGS} ${WEAK_SYMBOL_LINK_FLAGS}
    LINK_LIBS ${ORC_LINK_LIBS}
    PARENT_TARGET orc)
else() # not Apple
  if (WIN32)
    set(ORC_BUILD_TYPE STATIC)

    set(ORC_IMPL_HEADERS
      ${ORC_COMMON_IMPL_HEADERS}
      coff_platform.h
      )

    set(ORC_SOURCES
      ${ORC_COMMON_SOURCES}
      coff_platform.cpp
      coff_platform.per_jd.cpp
      )

    if (MSVC)
      set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreadedDLL")
      set(ORC_CFLAGS ${ORC_CFLAGS} /D_HAS_EXCEPTIONS=0 )
    endif()
  else()
    set(ORC_BUILD_TYPE STATIC)

    set(ORC_IMPL_HEADERS
      ${ORC_COMMON_IMPL_HEADERS}
      elfnix_platform.h
      )

    set(ORC_SOURCES
      ${ORC_COMMON_SOURCES}
      elfnix_platform.cpp
      )

    set(ORC_ASM_SOURCES
      elfnix_tls.x86-64.S
      elfnix_tls.aarch64.S
      elfnix_tls.ppc64.S
      sysv_reenter.arm64.S
      sysv_reenter.x86-64.S
      )
  endif()

  foreach(arch ${ORC_SUPPORTED_ARCH})
    if(NOT CAN_TARGET_${arch})
      continue()
    endif()

    add_compiler_rt_object_libraries(RTOrc
      ARCHS ${arch}
      SOURCES ${ORC_SOURCES} ${ORC_ASM_SOURCES}
      ADDITIONAL_HEADERS ${ORC_IMPL_HEADERS}
      CFLAGS ${ORC_CFLAGS}
      DEPS ${ORC_DEPS})

    # Common ORC archive for instrumented binaries.
    add_compiler_rt_runtime(orc_rt
      ${ORC_BUILD_TYPE}
      ARCHS ${arch}
      CFLAGS ${ORC_CFLAGS}
      LINK_FLAGS ${ORC_LINK_FLAGS}
      LINK_LIBS ${ORC_LINK_LIBS}
      OBJECT_LIBS ${ORC_COMMON_RUNTIME_OBJECT_LIBS} RTOrc
      PARENT_TARGET orc)
  endforeach()
endif() # not Apple

add_subdirectory(tests)

=== lib/DebugInfo/DWARF/CMakeLists.txt ===
add_llvm_component_library(LLVMDebugInfoDWARF
  DWARFAbbreviationDeclaration.cpp
  DWARFAddressRange.cpp
  DWARFAcceleratorTable.cpp
  DWARFCompileUnit.cpp
  DWARFContext.cpp
  DWARFDataExtractor.cpp
  DWARFDebugAbbrev.cpp
  DWARFDebugAddr.cpp
  DWARFDebugArangeSet.cpp
  DWARFDebugAranges.cpp
  DWARFDebugFrame.cpp
  DWARFDebugInfoEntry.cpp
  DWARFDebugLine.cpp
  DWARFDebugLoc.cpp
  DWARFDebugMacro.cpp
  DWARFDebugPubTable.cpp
  DWARFDebugRangeList.cpp
  DWARFDebugRnglists.cpp
  DWARFDie.cpp
  DWARFExpression.cpp
  DWARFFormValue.cpp
  DWARFGdbIndex.cpp
  DWARFListTable.cpp
  DWARFLocationExpression.cpp
  DWARFTypeUnit.cpp
  DWARFUnitIndex.cpp
  DWARFUnit.cpp
  DWARFVerifier.cpp

  ADDITIONAL_HEADER_DIRS
  ${LLVM_MAIN_INCLUDE_DIR}/llvm/DebugInfo/DWARF
  ${LLVM_MAIN_INCLUDE_DIR}/llvm/DebugInfo

  LINK_COMPONENTS
  BinaryFormat
  Object
  Support
  TargetParser
  )

=== lib/Target/AVR/TargetInfo/CMakeLists.txt ===
include_directories( ${CMAKE_CURRENT_BINARY_DIR}/..
                     ${CMAKE_CURRENT_SOURCE_DIR}/.. )

add_llvm_component_library(LLVMAVRInfo
  AVRTargetInfo.cpp

  LINK_COMPONENTS
  MC
  Support

  ADD_TO_COMPONENT
  AVR
)

add_dependencies(LLVMAVRInfo AVRCommonTableGen)

=== lib/Target/SPIRV/Analysis/CMakeLists.txt ===
add_llvm_component_library(LLVMSPIRVAnalysis
  SPIRVConvergenceRegionAnalysis.cpp

  LINK_COMPONENTS
  Analysis
  Core
  Support
  TransformUtils

  ADD_TO_COMPONENT
  SPIRV
  )

=== lib/scudo/standalone/fuzz/CMakeLists.txt ===
if (LLVM_USE_SANITIZE_COVERAGE)
  add_executable(get_error_info_fuzzer
      get_error_info_fuzzer.cpp)
  set_target_properties(
      get_error_info_fuzzer PROPERTIES FOLDER "Fuzzers")
  target_compile_options(
      get_error_info_fuzzer PRIVATE -fsanitize=fuzzer)
  set_target_properties(
      get_error_info_fuzzer PROPERTIES LINK_FLAGS -fsanitize=fuzzer)
  target_include_directories(
      get_error_info_fuzzer PRIVATE .. ../include)
endif()

=== PKGBUILD ===
# Maintainer: Mateusz Mikuła <oss@mateuszmikula.dev>

_compiler=clang

pkgbase=llvm
pkgname=("llvm"
         "clang"
         "clang-analyzer"
         "compiler-rt"
         "lld")
_version=20.1.8
_rc=""
_tag=llvmorg-${_version}${_rc}
pkgver=${_version}${_rc/-/}
pkgrel=2
pkgdesc="C language family frontend for LLVM"
arch=('i686' 'x86_64')
url="https://llvm.org/"
msys2_references=(
  "cpe: cpe:/a:llvm:llvm"
)
license=("spdx:Apache-2.0 WITH LLVM-exception")
makedepends=('cmake'
             "$_compiler"
             'ninja'
             'pkgconf'
             'python'
             'git'
             'libzstd-devel'
             'zlib-devel'
             )
_url=https://github.com/llvm/llvm-project/releases/download/${_tag}
source=("${_url}/llvm-${pkgver}.src.tar.xz"{,.sig}
        "${_url}/clang-${pkgver}.src.tar.xz"{,.sig}
        "${_url}/compiler-rt-${pkgver}.src.tar.xz"{,.sig}
        "${_url}/lld-${pkgver}.src.tar.xz"{,.sig}
        "${_url}/cmake-${pkgver}.src.tar.xz"{,.sig}
        "${_url}/libunwind-${pkgver}.src.tar.xz"{,.sig}
        "${_url}/runtimes-${pkgver}.src.tar.xz"{,.sig}
        "${_url}/third-party-${pkgver}.src.tar.xz"{,.sig}
        "0001-LLVM-Cygwin-Fix-symbol-visibility-definition.patch"
        "0002-LLVM-Cygwin-Remove-special-case-for-CXX-extensions-o.patch"
        "0003-LLVM-Cygwin-Fix-shared-library-name-136599.patch"
        "0004-LLVM-Cygwin-Fix-Signals-compatibility-with-Cygwin-AP.patch"
        "0005-LLVM-TargetParser-Handle-msys-targets-the-same-as-cy.patch"
        "0006-LLVM-Cygwin-Define-_GNU_SOURCE-on-Cygwin-as-well.-13.patch"
        "0007-Cygwin-Emit-COMDAT-name-correctly-for-Cygwin-138621.patch"
        "0008-LLVM-Cygwin-add-workaround-for-blocking-connect-acce.patch"
        "0009-Support-Cygwin-Fix-handling-of-Process-symbol-lookup.patch"
        "0010-Cygwin-Define-LLVM_ABI-for-Cygwin-143222.patch"
        "0011-Cygwin-CYGWIN-is-not-WIN32-in-current-CMake-143130.patch"
        "0012-Cygwin-Don-t-use-version-script-for-Cygwin-target-14.patch"
        "0013-LLVM-Tests-remove-exeext-from-lli-child-target-param.patch"
        "0014-LLVM-Support-Cygwin-Add-threading-support-for-Cygwin.patch"
        "0015-LLVM-Cygwin-Enable-dynamic-linking-of-libLLVM-146440.patch"
        "0016-LLVM-Cygwin-Enable-conditions-that-are-shared-with-M.patch"
        "0017-llvm-objcopy-COFF-Ignore-associative-sections-in-exe.patch"
        "0018-lli-Fix-crash-with-no-process-syms-on-MinGW-151386.patch"
        "0019-llvm-Enable-building-Analysis-plugins-on-Cygwin-1513.patch"
        "0020-LLVM-adjust-lit.cfg.py-for-Cygwin-151416.patch"
        "0021-LLVM-Support-Fix-tests-on-Cygwin-151417.patch"
        "0022-LLVM-lit-add-system-cygwin-feature-152780.patch"
        "0023-hack-tablegentest.patch"
        "0101-Cygwin-Global-symbols-should-be-external-by-default-.patch"
        "0102-Clang-Cygwin-Enable-few-conditions-that-are-shared-w.patch"
        "0103-Cygwin-Enable-TLS-on-Cygwin-target-138618.patch"
        "0104-Clang-Cygwin-Fix-symbol-visibility-definition-138118.patch"
        "0105-Cygwin-RTTI-and-VTable-should-be-dllexport-ed-139798.patch"
        "0106-Clang-Cygwin-Disable-shared-libs-on-Cygwin-by-defaul.patch"
        "0107-Clang-Cygwin-Remove-erroneous-_WIN32-define-and-clea.patch"
        "0108-Clang-Cygwin-don-t-use-Bsymbolic-functions-138217.patch"
        "0109-hack-cygwin-allow-multiple-definition-in-c-index-tes.patch"
        "0110-Clang-Driver-add-a-Cygwin-ToolChain-135691.patch"
        "0111-Clang-Driver-use-__cxa_atexit-by-default-on-Cygwin.-.patch"
        "0112-Clang-CMake-use-CMakePushCheckState-138783.patch"
        "0113-CMake-respect-LLVMConfig.cmake-s-LLVM_DEFINITIONS.patch"
        "0114-Cygwin-Internal-class-in-explicitly-instantiation-de.patch"
        "0115-Cygwin-Template-instantiations-should-be-exported-by.patch"
        "0116-Clang-Cygwin-va_list-must-be-treated-like-normal-Win.patch"
        "0117-Clang-Cygwin-wint_t-is-unsigned-int-143117.patch"
        "0118-scan-build-Windows-Fix-driver-name-transformation-in.patch"
        "0119-libclang-Add-missing-dllexport-annotation-147108.patch"
        "0120-libclang-Cygwin-Use-__declspec-dllexport-for-libclan.patch"
        "0121-libclang-Cygwin-Use-LLVM_EXPORTED_SYMBOL_FILE-.def-f.patch"
        "0122-Tests-Add-system-cygwin-feature-and-use-it.-152611.patch"
        "0201-LLD-Cygwin-Implement-dll-search-prefix-143263.patch"
        "0202-LLD-COFF-Ensure-.bss-is-merged-at-the-end-of-a-secti.patch"
        "0203-LLD-COFF-add-__-data-bss-_-start-end-__-symbols-for-.patch"
        "0204-LLD-MinGW-Fall-back-to-using-default-target-if-no-m-.patch"
        "0205-LLD-CMake-fix-testing-standalone-build-without-insta.patch"
        "0206-LLD-Cygwin-Add-libcygwin-and-libmsys-2.0-to-exclude-.patch"
        )
sha256sums=('e1363888216b455184dbb8a74a347bf5612f56a3f982369e1cba6c7e0726cde1'
            'SKIP'
            'b7a1b7b0af7b9c7596af6bd46e36d11321926eaa66a7a7dc957ab0a1375ee4b0'
            'SKIP'
            '15277402f6fd63397c0917a5c7171cda82d16d226094b828c1ed0f58f73b9c69'
            'SKIP'
            '8281462d62cae67dfe5fdbb4da0d82bc62e0a86d4d4f758b0b601d44f09fd987'
            'SKIP'
            '3319203cfd1172bbac50f06fa68e318af84dcb5d65353310c0586354069d6634'
            'SKIP'
            '0bced9d701e300f8fe6599523367e214c1f928ac559afceece58f47018e9c4a7'
            'SKIP'
            '86b375ab217619d018f6875b7c71106ffab5ab21c425f414a11468c2a8262819'
            'SKIP'
            '9a4e452a8163732d417db067a89190fcda823cb3aa33199e834ac7c028923f4b'
            'SKIP'
            'b59cbff2a7c102a018a8cc773d67ac6694837bd2a8efbef2f362ef7471f7cce5'
            '17c42bd648aca828a8710ca03e47c617cc93f1827d56f4955bb3d071feb32709'
            '40c0aa890514e68cdefc321ff6a06b65e469473160c31624331477704095e418'
            'f1b2a62c40b27270f396a72ee9e80c06d17f8f36942250d68e5b002dcf438260'
            '7aa4f78e66d7492762c4c578989fe625edc620366f4fc608f5ea432117dc1f82'
            '5c9776d8aaae83607dddca8d341ea94d434f720a8ea35f15450c13812f1c045f'
            '9e07a313f9a30278f566bce045309ba2a5dc070247ba969eb3ff162dc3958648'
            '9a37d8954bacd38dbb971a9c7814955605b9e5d549d0190c641c90878f1c0349'
            '7edd21d8ad3f6a5961de07bd69ab890db2d0f68c0b8c1c033a2f6a4393211ce9'
            '2b28cb44accbcdc2baee97ff965f747ee9403414ba859e4b465aa75f06bdceec'
            '677ba2a562716183a69b868d7f75b64e9109e6fc8d99dae196964f5573e40219'
            '1070f3a7ce03c472c9e2155464c9907f8ba27fa15df707396e59c9085b49c0ab'
            '9194df20a37702827037646fa93b4169554fb050a4b80efd5b942407ac44b55a'
            '84a771685a0a3220218de157069047e1fcb8d921b14d9ecc75a0cbd912cafff7'
            '45e79dfe7dcab1202274021040f3d7637e992b56a5a895d0ccbaff60626147ad'
            'b2c5441adcd95a8b25c83aa454bf0f06af117612fe5525aede8d2b5d7eff2470'
            'af5cea6aab4c86d3c137ca21d28c5eeaec918d68a045530ab8f4b45e8506290f'
            'e62dddc3e533cd2729f4ed8f51b898eb4214f2b9db15062f818c063fab85aee0'
            '499eba68cbb2a3a50a1e9a1ba211651bd5db7cab48b5154ca3cb37a44c2b2a0c'
            'd382b9f7012df9702e9c52c04d63620a0febb607b8656bef06f8bb98e59e73b9'
            'a7a17329a247e4bdc4d9b27f860c757ae153a754b0e0ce018a8a72ff06a803a8'
            '5431019c3a6fae561b675c60545d80278d914b78e12f9ae5c59ab0ce7dc6508d'
            '7cb70e14a5c6e87ef28427356ad3d366d58c367b2039d2a3bf92fa7dee33d79d'
            'c1e29c6aa62c075975b76c38fe0d60fe765f2527611f4336d60152afd1d0be98'
            '13e4b046406ffde1af3567e204a38fd7955d09ee4c493b2f3ec6bb48b0112dcd'
            '0db6ad5d5709f8f9031f57a9d33fa7c92ab95461c82e7b0eff72eec026f5169b'
            'c12a74c2d03f9ff5f8b98e546e2a3be99f74ff6d7ee64e0a95eefb20c8b4b3b9'
            'f0ddc7573db6d57aab0fa3cac787e2f39d061bfe38b01e1ec30d1c691142b38f'
            'cc4d53a46d80a0b5e7b193b888b3da6f87e523156e977ca08fdad17b466c288e'
            'a666029b966bb3ec4035d60743c78df56f1898bbd64126ac7e191a1d35976420'
            '6b65a05a9642888009080fb0295934de7ead96366cd76a9824bc9a941318718a'
            '771d26add61c8ac4e4f501d4852346e3e6807e1781cd33955f10816a5b4244c1'
            'c625e5a8c4803c169f3de0bf2ce666a2e67f70a2e126110b365562f58d82d9f7'
            'ba70c891d3653873a64d5eff93f3958f2dd09f7fa43560fdf4b3e18c38d47e70'
            'a9c6a0dda178d8a0e5e29c68eba177c8055242159ab8dee98fca6a78546825f1'
            'b2e44bcb7014f1384bfd12e55b138e53efdf7aaafe35bb912f60a30d92a7e1cb'
            '7c3d364c3bd23097c44dd5eb3583dcaf6b8e7f6790411a61da149aad74d3e94b'
            '019d1be80860be7f1d46a9da86e28eec926b7df21da8181a3812416e08f8c59e'
            '57dd8f7e859c9baf47c7ec1f92a081cdfb5304b2edc3828b01dfcc59e29ad6ac'
            'e7d764fad2d93fc76900365ae3baa659563ac5c4f89bb2fe4bdc63fdb453d0f9'
            '497ca7968b639cead910b0b383df099f5d5539531d6a6ff0f8ecd71d7ff6cd4c'
            '103c2907fe19dc0bf1909268cee356a183ce1c9bd5b1d38a9e9de92475530b6f'
            '2956145e72166ad997261d38ecca376e4fa3485ef4eb6a2eb83db9f77cce1d24'
            'e926774591c7806d3b58cf541c88c526ec239b92f5c42fe2e02cab4b270e4cd6'
            '8d4172d88163efa7b9902b8a01e9f052bbb04374cd8b36aba3382bb82193af8f'
            'd232026664efe2c1f076909e7cb77f35d530af4613c3212cde1801ca20c54b09'
            'c383fa5f2d8824992091ea203d8236494fa5d76f2701af2c4df5dd30a49e62fa'
            'f6fd632ff804176fc1c02122a4f4a522d2c82c024db7b66bc3838b15466b5b69'
            '1f5e5fb086d7cd043e2a9d6f3965c2a8520393b5fcc4d2a354d89d6e2fcabaf1'
            '517afbd61320b240636b425c0acca67ab35b7ddaa563cc2bceeb0f909de906d3'
            'd7903409e1611f9bd00987ebdd9e81dd0cc6a2d44f87241d6e0e145f1dc9f682')
validpgpkeys=('B6C8F98282B944E3B0D5C2530FC3042E345AD05D'  # Hans Wennborg, Google.
              '474E22316ABF4785A88C6E8EA2C794A986419D8A'  # Tom Stellard
              'D574BD5D1D0E98895E3BF90044F2485E45D59042') # Tobias Hieta
noextract=(clang-${pkgver}.src.tar.xz)

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

revert_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Reverting ${_patch}"
    patch -p1 -i "${srcdir}/${_patch}"
  done
}

apply_git_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp2 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd "${srcdir}"
  plain "Extracting clang-${pkgver}.src.tar.xz due to symlink(s) without pre-existing target(s)"
  tar -xJf "${srcdir}"/clang-${pkgver}.src.tar.xz -C "${srcdir}" || true

  # Rename Directories
  # We need libunwind for LLD: https://github.com/llvm/llvm-project/issues/48572
  for pkg in llvm clang compiler-rt lld cmake libunwind runtimes third-party; do
    mv ${pkg}-$pkgver.src ${pkg}
  done

  # Patch llvm
  cd "${srcdir}"/llvm
  apply_git_patch_with_msg 0001-LLVM-Cygwin-Fix-symbol-visibility-definition.patch
  apply_git_patch_with_msg 0002-LLVM-Cygwin-Remove-special-case-for-CXX-extensions-o.patch
  apply_git_patch_with_msg 0003-LLVM-Cygwin-Fix-shared-library-name-136599.patch
  apply_git_patch_with_msg 0004-LLVM-Cygwin-Fix-Signals-compatibility-with-Cygwin-AP.patch
  apply_git_patch_with_msg 0005-LLVM-TargetParser-Handle-msys-targets-the-same-as-cy.patch
  apply_git_patch_with_msg 0006-LLVM-Cygwin-Define-_GNU_SOURCE-on-Cygwin-as-well.-13.patch
  apply_git_patch_with_msg 0007-Cygwin-Emit-COMDAT-name-correctly-for-Cygwin-138621.patch
  apply_git_patch_with_msg 0008-LLVM-Cygwin-add-workaround-for-blocking-connect-acce.patch
  apply_git_patch_with_msg 0009-Support-Cygwin-Fix-handling-of-Process-symbol-lookup.patch
  apply_git_patch_with_msg 0010-Cygwin-Define-LLVM_ABI-for-Cygwin-143222.patch
  apply_git_patch_with_msg 0011-Cygwin-CYGWIN-is-not-WIN32-in-current-CMake-143130.patch
  apply_git_patch_with_msg 0012-Cygwin-Don-t-use-version-script-for-Cygwin-target-14.patch
  apply_git_patch_with_msg 0013-LLVM-Tests-remove-exeext-from-lli-child-target-param.patch
  apply_git_patch_with_msg 0014-LLVM-Support-Cygwin-Add-threading-support-for-Cygwin.patch
